#include <pspsdk.h>
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <pspsuspend.h>
#include <psppower.h>
#include <pspreg.h>
#include <psprtc.h>
#include <psputils.h>
#include <pspgu.h>
#include <pspgum.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <vlf.h>
#include <malloc.h>
#include <pspiofilemgr.h>
#include "include/bakonoldfw.h"
#include "include/bakonnew.h"
#include "include/bakon371.h"

PSP_MODULE_INFO("BakonICE Installer", 0, 1, 1);

enum installmodes{
	MODE_LOWFW = 0,
	MODE_HIGHFW = 1,
	MODE_371 = 2
};

char *main_text = "BakonICE Version 2.0 Installer";

SceCtrlData pad;
int mode;
float y = 20;
VlfPicture logo;
VlfText buffer, buffer2, title;
VlfBatteryIcon battery_icon;

void refreshButtons(void)
{
	sceCtrlPeekBufferPositive(&pad, 1);
	return;
}

void add_to_gametxt()
{
	char *gametxtoutline = "\nms0:/seplugins/%s";
	char gametxtdata[100];
	if(mode != MODE_371) sprintf(gametxtdata, gametxtoutline, "bakon.prx");
	else sprintf(gametxtdata, gametxtoutline, "bakon371.prx");
	signed int fd0 = sceIoOpen("ms0:/seplugins/game.txt", PSP_O_WRONLY | PSP_O_CREAT, 0777);
	sceIoLseek(fd0, 0, 2);
	sceIoWrite(fd0, gametxtdata, strlen(gametxtdata));
	sceIoClose(fd0);
	pspDebugScreenPrintf("Writing game.txt...\n");
	return;
}

void write_data(const number)
{
	char *pathoutline = "ms0:/seplugins/%s.prx";
	char path[100];
	if(mode == MODE_371) sprintf(path, pathoutline, "bakon371");
	else sprintf(path, pathoutline, "bakon");
	signed int fd0 = sceIoOpen(path, PSP_O_CREAT | PSP_O_WRONLY | PSP_O_TRUNC, 0777);
	switch(mode)
	{
		case MODE_HIGHFW:
		sceIoWrite(fd0, bakonnew, size_bakonnew);
		break;
		case MODE_LOWFW:
		sceIoWrite(fd0, bakonoldfw, size_bakonoldfw);
		break;
		case MODE_371:
		sceIoWrite(fd0, bakon371, size_bakon371);
		break;
	}
	sceIoClose(fd0);
	fd0 = sceIoOpen("ms0:/seplugins/bakon/bakoncheat.txt", PSP_O_CREAT | PSP_O_WRONLY, 0777);
	sceIoClose(fd0);//Create a dummy bakoncheat file.
	//vlfGuiRemoveText(buffer);
	//vlfGuiCancelLateralMenu();
	//buffer = vlfGuiAddText(120, 40, "Thank You For Installing, Exiting Now");
	//sceKernelDelayThread(2000000);
	//sceKernelExitGame();
	return VLF_EV_RET_NOTHING;
}

void exit_game()
{
	sceKernelExitGame();
}

int add_exit_menu()
{
	char *items[] = { "Exit" };
	vlfGuiRemoveText(buffer);
	vlfGuiCancelCentralMenu();
	buffer = vlfGuiAddText(217, 90, "Done!");
	vlfGuiCentralMenu(1, items, 0, &exit_game, 0, 0);
	return;
}

int menu_select_firmware()
{
	void menu_sel(int select)
	{
		if(select < 3) write_data(select);
		else sceKernelExitGame();
		add_exit_menu();
		return VLF_EV_RET_REMOVE_HANDLERS;
	}
	buffer = vlfGuiAddText(125, 40, "Please Select Your Firmware");
	//vlfGuiSetTextAlignment(buffer, VLF_ALIGNMENT_CENTER);
	//buffer2 = vlfGuiAddText(135, 60, "Installer Will Exit Afterward");
	//vlfGuiSetTextAlignment(buffer2, VLF_ALIGNMENT_CENTER);
	vlfGuiSetTextFocus(buffer);
	char *items[] = { "> 3.7X M33", "3.7X M33", "< 3.7X M33", "Exit"};
	title = vlfGuiAddText(0, 0, main_text);
	vlfGuiSetTitleBar(title, NULL, 1, 0);
	battery_icon = vlfGuiAddBatteryIconSystem(1000);
	vlfGuiCentralMenu(4, items, 0, menu_sel, 0, 0);
	//for(;;) vlfGuiDrawFrame();
	return VLF_EV_RET_NOTHING;
}



int fxmain(void)
{
	char *items[] = { "Start Installer", "Exit" };
	int menu_0_sel(int number)
	{
		switch(number)
		{
			case 0:
			vlfGuiRemovePicture(logo);
			menu_select_firmware();
			return VLF_EV_RET_REMOVE_HANDLERS | VLF_EV_RET_REMOVE_OBJECTS;
			case 1:
			sceKernelExitGame();
			break;
		}
		return VLF_EV_RET_NOTHING;
	}
	vlfGuiSystemSetup(1, 1, 1);		
	vlfGuiLateralMenu(2, items, 0, menu_0_sel, 100);
	logo = vlfGuiAddPictureFile("logo.png", 95, 80);
	for(;;) vlfGuiDrawFrame();
	return 0;
}
